///////////////////////////////////////////////////////////////////////
//    Copyright (C) 1997
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//    authors: Andrey V. Astrelin
//             Oleg L. Machulski
//    mail: machulsk@shade.msu.ru
///////////////////////////////////////////////////////////////////////
/**********************************************
*   Linux include file for MMMX Editor        *
*   Contains Linux  Spacific functions        *
***********************************************/

#ifndef __INCLUDED_MMM_LINUX__
#define __INCLUDED_MMM_LINUX__

#define EXECUTER_FILENAME "__mmm__.bat"
#define BASE_CONFIG_FILE_NAME "mmm_base.cfg"
//&<<&#include 
#include "mmmx.h"
#include "mmmgrep.h"
#include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <linux/tty.h>
#include <linux/kd.h>
#include <linux/vt.h>
#include <signal.h>
#include <termios.h>       /* for tcget(set)attr */
#include <sys/ioctl.h>
#include <dirent.h>
#include <sys/stat.h>
//&>>&1 0 1 11

void DrawLine(char *Str, int PosY, char Attr,int slen);

//&<<&class mmm_Screen {
class mmm_Screen {
   char *v_screen;
   int need;
   int WIDTH,HEIGHT;
   int curatr;
   int OldScr,OldCl;            /// only for compatibility ?
   char *OldCurs,OldAttr;       /// only for compatibility ?
   void setatr(int atr);
public:
   mmm_Screen();
   ~mmm_Screen();
   void SetCursor(int x,int y,int attr);
   void ClrCursor();
   void Line(char *str,int len,int x,int y);
   int &Need(){ return need; }
   int GetH(){ return HEIGHT; }
   int GetW(){ return WIDTH; }
   void View(){};
   };
//&>>&1 0 1 B
extern mmm_Screen mmm_screen;

//&<<&class mmm_KeyBoard{
class mmm_KeyBoard{
    int ed_gflag;
    struct termios t1;
    int om;
    void InitKeyboardLayout();
    char *InitDefaultAltCase();
public:
    char *AltCase;
    char keys[4][128];
    int LastScanCode;
    void SetACode(int n);
    mmm_KeyBoard();
    ~mmm_KeyBoard();
    int GetScan();
    friend void SegmentViolationHandler(int a);
    void ChangeConsole(int num);
};
//&>>&8 0 8 14
extern mmm_KeyBoard mmm_KBD;

void MkScan(int scancode);

#endif
//&>>&0 0 0 2F
